﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Net;
using System.Windows.Resources;
using System.IO;
using System.Xml;
using System.Runtime.Serialization.Json;

namespace AppNotifiSender
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<Uri> deserializedListUri;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void ToastButton_Click(object sender, RoutedEventArgs e)
        {
            string appId = "1";
            //string baseUri = string.Format("http://localhost:19976/Notifications/GetSubscribers?appId={0}", appId);
            string baseUri = string.Format("http://192.168.10.174:/Notifications/GetSubscribers?appId={0}", appId);

            GetSubscribers(baseUri);
            
        }

        private void SendToast()
        {

            HttpWebRequest sendNotificationRequest = (HttpWebRequest)WebRequest.Create(deserializedListUri[0]);

            // We will create a HTTPWebRequest that posts the toast notification to the Microsoft Push Notification Service.
            // HTTP POST is the only allowed method to send the notification.
            sendNotificationRequest.Method = "POST";

            // The optional custom header X-MessageID uniquely identifies a notification message. 
            // If it is present, the // same value is returned in the notification response. It must be a string that contains a UUID.
            // sendNotificationRequest.Headers.Add("X-MessageID", "<UUID>");

            var title = "test Title";
            var subtitle = "test SubTitle";
            // Create the toast message.


            string toastMessage = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
            "<wp:Notification xmlns:wp=\"WPNotification\">" +
               "<wp:Toast>" +
                    "<wp:Text1>" + title + "</wp:Text1>" +
                    "<wp:Text2>" + subtitle + "</wp:Text2>" +
               "</wp:Toast> " +
            "</wp:Notification>";

            // Sets the notification payload to send.
            byte[] notificationMessage = Encoding.Default.GetBytes(toastMessage);

            // Sets the web request content length.
            sendNotificationRequest.ContentLength = notificationMessage.Length;
            sendNotificationRequest.ContentType = "text/xml";
            sendNotificationRequest.Headers.Add("X-WindowsPhone-Target", "toast");
            sendNotificationRequest.Headers.Add("X-NotificationClass", "2");

            using (Stream requestStream = sendNotificationRequest.GetRequestStream())
            {
                requestStream.Write(notificationMessage, 0, notificationMessage.Length);
            }

            // Send the notification and get the response.
            HttpWebResponse response = (HttpWebResponse)sendNotificationRequest.GetResponse();
            string notificationStatus = response.Headers["X-NotificationStatus"];
            string notificationChannelStatus = response.Headers["X-SubscriptionStatus"];
            string deviceConnectionStatus = response.Headers["X-DeviceConnectionStatus"];

            // Display the response from the Microsoft Push Notification Service.  
            // Normally, error handling code would be here.  In the real world, because data connections are not always available,
            // notifications may need to be throttled back if the device cannot be reached.

            resultTextBlock.Text = notificationStatus + " | " + deviceConnectionStatus + " | " + notificationChannelStatus;
        }

        private void GetSubscribers(string baseUri)
        {
            WebClient webclient = new WebClient();
            webclient.DownloadDataCompleted += new DownloadDataCompletedEventHandler(webclient_DownloadDataCompleted);
            webclient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(webclient_DownloadStringCompleted);
            webclient.DownloadStringAsync(new Uri(baseUri));
        }

        void webclient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {                           
            MemoryStream ms = new MemoryStream(Encoding.UTF8.GetBytes(e.Result));
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(List<Uri>));
            deserializedListUri = serializer.ReadObject(ms) as List<Uri>;

            SendToast();
        }

        static void webclient_DownloadDataCompleted(object sender, DownloadDataCompletedEventArgs e)
        {
            throw new NotImplementedException();
        }
    }
}
